package org.spring.forge;



import javax.enterprise.event.Event;
import javax.inject.Inject;

import org.jboss.forge.project.Project;
import org.jboss.forge.project.facets.JavaSourceFacet;
import org.jboss.forge.project.facets.events.InstallFacets;
import org.jboss.forge.resources.DirectoryResource;
import org.jboss.forge.resources.FileResource;
import org.jboss.forge.shell.ShellColor;
import org.jboss.forge.shell.ShellPrompt;
import org.jboss.forge.shell.plugins.Command;
import org.jboss.forge.shell.plugins.PipeOut;
import org.jboss.forge.shell.plugins.Plugin;
import org.jboss.forge.spec.javaee.CDIFacet;
import org.spring.forge.template.TemplateEvaluator;

public class SpringPlugin implements Plugin{

    private final Project project;

//    private final Event<InstallFacets> installFacets;

    //private static final String PRIMEFACES_THEME = "primefaces.THEME";

    @Inject
    private ShellPrompt prompt;

    @Inject
    public SpringPlugin(final Project project) {
        this.project = project;
       // this.installFacets = event;
    }	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

    private void addTemplateVariables(TemplateEvaluator someEvaluator) {
/*        PrimefacesFacet primeFacet = project.getFacet(PrimefacesFacet.class);

        if (primeFacet.getVersion().getVersion() == 2) {
            someEvaluator.addParameters("primefacesTargetName", "http://primefaces.prime.com.tr/ui");
        } else {
            someEvaluator.addParameters("primefacesTargetName", "http://primefaces.org/ui");
        }
*/
        
        
        boolean hasCDI = project.hasFacet(CDIFacet.class);
        JavaSourceFacet source = project.getFacet(JavaSourceFacet.class);

        someEvaluator.addParameters("basePackage", source.getBasePackage());

    }	
	
	   @Command("install-example-facelet")
	    public void installExampleFacelets(final PipeOut pipeOut) {
	        //assertInstalled();
	        TemplateEvaluator evaluator = TemplateEvaluator.getInstance();
	        addTemplateVariables(evaluator);
	        //createFaceletFiles(evaluator, pipeOut);
	        createSpringService(evaluator, pipeOut);
	      
	    }
	   
	    private void createSpringService(TemplateEvaluator someEvaluator, final PipeOut pipeOut) {
	    	System.out.print("in createspringfile ");
	    	JavaSourceFacet source = project.getFacet(JavaSourceFacet.class);
	        DirectoryResource sourceRoot = source.getBasePackageResource();
	        FileResource<?> indexPage = (FileResource<?>) sourceRoot.getChild("SpringService.java");



	        indexPage.setContents(someEvaluator.evaluate("/org/spring/forge/SpringService.vm"));
	        System.out.print("springfile written");
	        //pipeOut.println(ShellColor.YELLOW, String.format(PrimefacesFacet.SUCCESS_MSG_FMT, "PrimeBean", "class"));
	    }
	   
	

}
